unit ggt_kgv_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Edit2: TEdit;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Edit3: TEdit;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Edit5: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button3Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit1.Clear;
  Edit2.Clear;
  Edit3.Clear;
  Edit4.Clear;
  Edit5.Clear;
  Edit1.SetFocus;
end;

function euklid(a,b: integer): integer;
var rest: integer;
begin
  while rest <> 0 do begin
    rest := a mod b;
    a := b;
    b := rest;
  end;
  result := a;
end;

function kgV(a,b: integer): integer;
begin
  result := ((a*b) div euklid(a,b));
end;

function nicco(a,b: integer): integer;
var
  hilf: integer;
begin
  while a <> b do begin
    if a > b then a := a - b
    else begin
      hilf := a;
      a := b;
      b := b - hilf;
    end;
  end;
  result := b;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  zahl_1, zahl_2, ggt_e, ggt_n, vielfaches: integer;
begin
  zahl_1 := StrToInt(Edit1.Text);
  zahl_2 := StrToInt(Edit2.Text);

  ggt_e := euklid(zahl_1, zahl_2);      //Berechnung des ggT nach EUKLID
  ggt_n := nicco(zahl_1,zahl_2);        //Berechnung des ggT nach NICCOMACHUS
  vielfaches := kgv(zahl_1,zahl_2);     //Berechnung des kgV

  Edit3.Text := IntToStr(ggt_e);
  Edit4.Text := IntToStr(ggt_n);
  Edit5.Text := IntToStr(vielfaches);
end;

end.
